# coding: utf-8

# flake8: noqa

"""
    Open Agent API

    An API for creating and interacting with AI agents, including chat completions, autonomous agents with tool usage, multi-agent teams, knowledge base search, and optional billing integration. Clients can authenticate via magic link or OAuth2 to obtain a token, or use API keys. 

    The version of the OpenAPI document: 0.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "0.7.0"

# import apis into sdk package
from open_agent_api.api.account_api import AccountApi
from open_agent_api.api.agents_api import AgentsApi
from open_agent_api.api.authentication_api import AuthenticationApi
from open_agent_api.api.billing_api import BillingApi
from open_agent_api.api.chat_api import ChatApi
from open_agent_api.api.mcp_api import MCPApi
from open_agent_api.api.teams_api import TeamsApi
from open_agent_api.api.tools_api import ToolsApi
from open_agent_api.api.default_api import DefaultApi
from open_agent_api.api.subscription_api import SubscriptionApi

# import ApiClient
from open_agent_api.api_response import ApiResponse
from open_agent_api.api_client import ApiClient
from open_agent_api.configuration import Configuration
from open_agent_api.exceptions import OpenApiException
from open_agent_api.exceptions import ApiTypeError
from open_agent_api.exceptions import ApiValueError
from open_agent_api.exceptions import ApiKeyError
from open_agent_api.exceptions import ApiAttributeError
from open_agent_api.exceptions import ApiException

# import models into sdk package
from open_agent_api.models.account_balance_info import AccountBalanceInfo
from open_agent_api.models.account_info import AccountInfo
from open_agent_api.models.account_portal_session_created_response import AccountPortalSessionCreatedResponse
from open_agent_api.models.account_subscription_info import AccountSubscriptionInfo
from open_agent_api.models.account_subscription_purchase import AccountSubscriptionPurchase
from open_agent_api.models.account_topup_request import AccountTopupRequest
from open_agent_api.models.account_topup_response import AccountTopupResponse
from open_agent_api.models.account_update_request import AccountUpdateRequest
from open_agent_api.models.account_usage_info import AccountUsageInfo
from open_agent_api.models.account_usage_info_item import AccountUsageInfoItem
from open_agent_api.models.agent import Agent
from open_agent_api.models.agent_completion_chunk import AgentCompletionChunk
from open_agent_api.models.agent_completion_request import AgentCompletionRequest
from open_agent_api.models.agent_completion_response import AgentCompletionResponse
from open_agent_api.models.agent_environment import AgentEnvironment
from open_agent_api.models.agent_message import AgentMessage
from open_agent_api.models.agent_message_citations import AgentMessageCitations
from open_agent_api.models.agent_message_content import AgentMessageContent
from open_agent_api.models.agent_message_metrics import AgentMessageMetrics
from open_agent_api.models.agent_message_references import AgentMessageReferences
from open_agent_api.models.agent_message_tool_call import AgentMessageToolCall
from open_agent_api.models.agent_message_tool_call_function import AgentMessageToolCallFunction
from open_agent_api.models.agent_toolkit_summary import AgentToolkitSummary
from open_agent_api.models.agents_get200_response import AgentsGet200Response
from open_agent_api.models.api_key_creation_request import ApiKeyCreationRequest
from open_agent_api.models.api_key_info import ApiKeyInfo
from open_agent_api.models.api_key_usage_info import ApiKeyUsageInfo
from open_agent_api.models.api_key_usage_response import ApiKeyUsageResponse
from open_agent_api.models.api_key_usage_response_time_series_inner import ApiKeyUsageResponseTimeSeriesInner
from open_agent_api.models.api_key_usage_response_usage_data import ApiKeyUsageResponseUsageData
from open_agent_api.models.api_key_usage_response_usage_data_billing_info import ApiKeyUsageResponseUsageDataBillingInfo
from open_agent_api.models.audio import Audio
from open_agent_api.models.auth_link_verify_token_get200_response import AuthLinkVerifyTokenGet200Response
from open_agent_api.models.auth_login_response import AuthLoginResponse
from open_agent_api.models.auth_magic_link_request import AuthMagicLinkRequest
from open_agent_api.models.chat_completion_request import ChatCompletionRequest
from open_agent_api.models.chat_completion_request_stop import ChatCompletionRequestStop
from open_agent_api.models.chat_completion_response import ChatCompletionResponse
from open_agent_api.models.chat_completion_response_choices_inner import ChatCompletionResponseChoicesInner
from open_agent_api.models.chat_completion_usage import ChatCompletionUsage
from open_agent_api.models.checkout_session_info import CheckoutSessionInfo
from open_agent_api.models.checkout_session_request import CheckoutSessionRequest
from open_agent_api.models.citations import Citations
from open_agent_api.models.cost_summary import CostSummary
from open_agent_api.models.cost_summary_event import CostSummaryEvent
from open_agent_api.models.document_citation import DocumentCitation
from open_agent_api.models.external_tool import ExternalTool
from open_agent_api.models.file import File
from open_agent_api.models.image import Image
from open_agent_api.models.location_inner import LocationInner
from open_agent_api.models.media import Media
from open_agent_api.models.o_auth_authorization_response import OAuthAuthorizationResponse
from open_agent_api.models.o_auth_callback_response import OAuthCallbackResponse
from open_agent_api.models.o_auth_device_code_request import OAuthDeviceCodeRequest
from open_agent_api.models.o_auth_device_code_response import OAuthDeviceCodeResponse
from open_agent_api.models.run_completed_event import RunCompletedEvent
from open_agent_api.models.run_response_event import RunResponseEvent
from open_agent_api.models.run_response_event1 import RunResponseEvent1
from open_agent_api.models.run_started_event import RunStartedEvent
from open_agent_api.models.server_setup_request import ServerSetupRequest
from open_agent_api.models.server_setup_response import ServerSetupResponse
from open_agent_api.models.sse_endpoint_mcp_sse_get200_response import SseEndpointMcpSseGet200Response
from open_agent_api.models.subscription_plan_info import SubscriptionPlanInfo
from open_agent_api.models.subscription_status import SubscriptionStatus
from open_agent_api.models.success_response import SuccessResponse
from open_agent_api.models.team import Team
from open_agent_api.models.team_members_inner import TeamMembersInner
from open_agent_api.models.team_message import TeamMessage
from open_agent_api.models.team_message_citations import TeamMessageCitations
from open_agent_api.models.team_run_request import TeamRunRequest
from open_agent_api.models.team_run_response import TeamRunResponse
from open_agent_api.models.teams_get200_response import TeamsGet200Response
from open_agent_api.models.teams_post_request import TeamsPostRequest
from open_agent_api.models.teams_post_request_members_inner import TeamsPostRequestMembersInner
from open_agent_api.models.teams_team_id_run_post200_response import TeamsTeamIdRunPost200Response
from open_agent_api.models.teams_team_id_run_post_request import TeamsTeamIdRunPostRequest
from open_agent_api.models.tool_call import ToolCall
from open_agent_api.models.tool_call_completed_event import ToolCallCompletedEvent
from open_agent_api.models.tool_call_completed_event1 import ToolCallCompletedEvent1
from open_agent_api.models.tool_call_result import ToolCallResult
from open_agent_api.models.tool_call_result_metrics import ToolCallResultMetrics
from open_agent_api.models.tool_call_started_event import ToolCallStartedEvent
from open_agent_api.models.tool_call_started_event1 import ToolCallStartedEvent1
from open_agent_api.models.toolkit import Toolkit
from open_agent_api.models.toolkit_function import ToolkitFunction
from open_agent_api.models.url_citation import UrlCitation
from open_agent_api.models.usage import Usage
from open_agent_api.models.user_subscription_create import UserSubscriptionCreate
from open_agent_api.models.user_subscription_response import UserSubscriptionResponse
from open_agent_api.models.validation_error import ValidationError
from open_agent_api.models.video import Video
