# coding: utf-8

"""
    Open Agent API

    An API for creating and interacting with AI agents, including chat completions, autonomous agents with tool usage, multi-agent teams, knowledge base search, and optional billing integration. Clients can authenticate via magic link or OAuth2 to obtain a token, or use API keys. 

    The version of the OpenAPI document: 0.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ChatCompletionUsage(BaseModel):
    """
    ChatCompletionUsage
    """ # noqa: E501
    input_tokens: Optional[StrictInt] = 0
    output_tokens: Optional[StrictInt] = 0
    total_tokens: Optional[StrictInt] = 0
    prompt_tokens: Optional[StrictInt] = 0
    completion_tokens: Optional[StrictInt] = 0
    prompt_tokens_details: Optional[Dict[str, Any]] = None
    completion_tokens_details: Optional[Dict[str, Any]] = None
    additional_metrics: Optional[Dict[str, Any]] = None
    time: Optional[Union[StrictFloat, StrictInt]] = None
    time_to_first_token: Optional[Union[StrictFloat, StrictInt]] = None
    __properties: ClassVar[List[str]] = ["input_tokens", "output_tokens", "total_tokens", "prompt_tokens", "completion_tokens", "prompt_tokens_details", "completion_tokens_details", "additional_metrics", "time", "time_to_first_token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChatCompletionUsage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChatCompletionUsage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "input_tokens": obj.get("input_tokens") if obj.get("input_tokens") is not None else 0,
            "output_tokens": obj.get("output_tokens") if obj.get("output_tokens") is not None else 0,
            "total_tokens": obj.get("total_tokens") if obj.get("total_tokens") is not None else 0,
            "prompt_tokens": obj.get("prompt_tokens") if obj.get("prompt_tokens") is not None else 0,
            "completion_tokens": obj.get("completion_tokens") if obj.get("completion_tokens") is not None else 0,
            "prompt_tokens_details": obj.get("prompt_tokens_details"),
            "completion_tokens_details": obj.get("completion_tokens_details"),
            "additional_metrics": obj.get("additional_metrics"),
            "time": obj.get("time"),
            "time_to_first_token": obj.get("time_to_first_token")
        })
        return _obj


